// Created on: 1991-03-05
// Created by: Remy GILET
// Copyright (c) 1991-1999 Matra Datavision
// Copyright (c) 1999-2014 OPEN CASCADE SAS
//
// This file is part of Open CASCADE Technology software library.
//
// This library is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License version 2.1 as published
// by the Free Software Foundation, with special exception defined in the file
// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
// distribution for complete text of the license and disclaimer of any warranty.
//
// Alternatively, this file may be used under the terms of Open CASCADE
// commercial license or contractual agreement.

#ifndef _GccEnt_BadQualifier_HeaderFile
#define _GccEnt_BadQualifier_HeaderFile

#include <Standard_Type.hxx>
#include <Standard_DefineException.hxx>
#include <Standard_SStream.hxx>
#include <Standard_DomainError.hxx>

class GccEnt_BadQualifier;
DEFINE_STANDARD_HANDLE(GccEnt_BadQualifier, Standard_DomainError)

#if !defined No_Exception && !defined No_GccEnt_BadQualifier
  #define GccEnt_BadQualifier_Raise_if(CONDITION, MESSAGE)                                         \
    if (CONDITION)                                                                                 \
      throw GccEnt_BadQualifier(MESSAGE);
#else
  #define GccEnt_BadQualifier_Raise_if(CONDITION, MESSAGE)
#endif

DEFINE_STANDARD_EXCEPTION(GccEnt_BadQualifier, Standard_DomainError)

#endif // _GccEnt_BadQualifier_HeaderFile
