// Copyright (c) 1999-2014 OPEN CASCADE SAS
//
// This file is part of Open CASCADE Technology software library.
//
// This library is free software; you can redistribute it and/or modify it under
// the terms of the GNU Lesser General Public License version 2.1 as published
// by the Free Software Foundation, with special exception defined in the file
// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
// distribution for complete text of the license and disclaimer of any warranty.
//
// Alternatively, this file may be used under the terms of Open CASCADE
// commercial license or contractual agreement.

#include <Interface_InterfaceModel.hxx>
#include <Interface_SignType.hxx>
#include <Standard_Transient.hxx>
#include <Standard_Type.hxx>
#include <TCollection_AsciiString.hxx>

IMPLEMENT_STANDARD_RTTIEXT(Interface_SignType, MoniTool_SignText)

TCollection_AsciiString Interface_SignType::Text(const Handle(Standard_Transient)& ent,
                                                 const Handle(Standard_Transient)& context) const
{
  TCollection_AsciiString          atext;
  Handle(Interface_InterfaceModel) model = Handle(Interface_InterfaceModel)::DownCast(context);
  if (ent.IsNull() || model.IsNull())
    return atext;
  atext.AssignCat(Value(ent, model));
  return atext;
}

Standard_CString Interface_SignType::ClassName(const Standard_CString typnam)
{
  char* tn = (char*)typnam;
  for (int i = 0; tn[i] != '\0'; i++)
  {
    if (tn[i] == '_')
      return &tn[i + 1];
  }
  return tn;
}
